local AddonName = "FlexBar2";

cyCircled_FlexBar2 = cyCircled:NewModule(AddonName)

function cyCircled_FlexBar2:AddonLoaded(addon)
	self.db = cyCircled:AcquireDBNamespace(AddonName)
	local GroupList = self:GetElements();
	cyCircled:RegisterDefaults(AddonName, "profile", GroupList)
	
	self:SetupElements(GroupList)

	-- Reskin when new buttons are created
	self:Hook(FlexBar2, "Create", "Reskin");
end

function cyCircled_FlexBar2:Reskin(_, Name)
	-- Call the hooked func to actualy create the button :)
	self.hooks[FlexBar2].Create(FlexBar2, Name);
	-- Regenerate button list
	self:SetupElements(self:GetElements());
	-- Reapply skins
	self:ApplySkin();
	self:ApplyColors();
end

function cyCircled_FlexBar2:GetElements()
	local GroupList = {Ungrouped = "Ungrouped buttons"};
	for GroupName in pairs(FlexBar2.Groups) do
		GroupList[GroupName] = GroupName;
	end
	return GroupList;
end

function cyCircled_FlexBar2:SetupElements(GroupList)
	self.elements = {}
	for GroupName in pairs(GroupList) do
		self.elements[GroupName] =
		{
			args = 
			{
				button = 
				{ 
					width = 35,
					height = 35, 
				},
				eborder = false,
			},
			elements = {},
		}
	end
	for ButtonName, ButtonObject in pairs(FlexBar2.Buttons) do
		local GroupName = "Ungrouped";
		if(ButtonObject.Group and ButtonObject.Group.Name) then
			GroupName = ButtonObject.Group.Name;
		end
		table.insert(self.elements[GroupName].elements, "FB2_BTN_" .. ButtonObject.uid);
	end
end
